using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;


namespace ComboGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(472, 432);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(376, 464);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(104, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Export";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 502);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = GetParentTable();
			this.gridDataBoundGrid1.DataSource = dt;
			
			this.gridDataBoundGrid1.AllowResizeToFit =false;

			this.gridDataBoundGrid1.Binder.InternalColumns["Date"].StyleInfo.Format = "MM/dd/yyyy";   
			this.gridDataBoundGrid1.Binder.InternalColumns["Time"].StyleInfo.Format = "HH:mm";   
			this.gridDataBoundGrid1.Binder.InternalColumns["DateTime"].StyleInfo.Format = "MM/dd/yyyy HH:mm:ss";   

			this.gridDataBoundGrid1.Binder.BindingListChanged +=new ListChangedEventHandler(Binder_BindingListChanged);
			this.gridDataBoundGrid1.CurrentCellChanged+=new EventHandler(gridDataBoundGrid1_CurrentCellChanged); 
			this.gridDataBoundGrid1.PrepareViewStyleInfo +=new GridPrepareViewStyleInfoEventHandler(gridDataBoundGrid1_PrepareViewStyleInfo);

			this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());   

		}

		#region DataTables

		private int numberParentRows = 12;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID",typeof(double))); //lower case p
			dt.Columns.Add(new DataColumn("ParentDec"));
			dt.Columns.Add(new DataColumn("DifferntCellType"));
			

			dt.Columns.Add(new DataColumn("Date",typeof(DateTime)));
			dt.Columns.Add(new DataColumn("Time",typeof(DateTime)));
			dt.Columns.Add(new DataColumn("DateTime",typeof(DateTime))); 
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[2] = string.Format("parentName{0}", i);
				dr[1] = string.Format("ChildName{0}", i);
				dr[3] = DateTime.Now; 
				dr[4] = DateTime.Now; 
				dr[5] = DateTime.Now; 
				dt.Rows.Add(dr);
			}
		 


			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("ChildID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			dt.Columns.Add(new DataColumn("other")); //upper case P
			dt.Columns.Add(new DataColumn("otherx")); //upper case P

			dt.Columns.Add(new DataColumn("ParentName"));
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);
				dr[5] = string.Format("parentName{0}",(i % numberParentRows));
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		
		#endregion

		private void button2_Click(object sender, System.EventArgs e)
		{
			Syncfusion.GridExcelConverter.GridExcelConverterControl gecc = new Syncfusion.GridExcelConverter.GridExcelConverterControl();

			SaveFileDialog saveFileDialog = new SaveFileDialog();
			saveFileDialog.Filter = "Files(*.xls)|*.xls";
			saveFileDialog.DefaultExt = ".xls";

			if(saveFileDialog.ShowDialog() == DialogResult.OK)
			{
				gecc.GridToExcel(this.gridDataBoundGrid1.Model, saveFileDialog.FileName,
					Syncfusion.GridExcelConverter.ConverterOptions.RowHeaders);            
			
				if(MessageBox.Show("Do you wish to open the xls file now?", "Export to Excel", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
				{
					Process proc = new Process();
					proc.StartInfo.FileName = saveFileDialog.FileName;
					proc.Start();
				}
			}
		}

		//To resize the row depending on sorting....CurrentRecord changes.
		private void Binder_BindingListChanged(object sender, ListChangedEventArgs e)
		{
			this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());   

		}

		//To resize the row depending on the cell changes...
		private void gridDataBoundGrid1_CurrentCellChanged(object sender, EventArgs e)
		{
			this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());   
		}

		private void gridDataBoundGrid1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			if( e.ColIndex > 0 && e.RowIndex > 0 )
			{
				string strValue  = this.gridDataBoundGrid1.Model[e.RowIndex,1].Text; 
				if( strValue != string.Empty )
				{
					int iValue = int.Parse(strValue);
					if( iValue %2 == 0 )
						e.Style.BackColor = Color.Orange;
					else
						e.Style.BackColor = Color.Pink;

				}
			}
		}
	}
}
